/**********************************************************************



  Filename:  student1.cpp

  Chapter:   1      Overview of C++ and Object Oriented Programming

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream>



enum year { fresh, soph, junior, senior, grad };

enum support { ta, ra, fellowship, other };



class student {

public:



   student(char* nm, int id, double g, year x);

   void  print() const;

private:

   int     student_id;

   double  gpa;

   year    y;

   char    name[30];

};





student::student(char* nm, int id, double g, year x)

       : student_id(id), gpa(g), y(x)

{

   strcpy(name, nm);

}



void student::print() const

{

    cout << endl << name << ", " << student_id << ", "

         << y << ", " << gpa << endl;

}



class grad_student : public student {

public:



   grad_student(char* nm, int id, double g,

                year x, support t, char* d, char* th);

   void print() const;

private:

   support  s;

   char     dept[10];

   char     thesis[80];

};





grad_student::grad_student

      (char* nm, int id, double g, year x, support t, char* d, char* th)

      : student (nm, id, g, x), s(t)

{

   strcpy(dept, d);

   strcpy(thesis, th);

}



void grad_student::print() const

{

   student::print();

   cout << dept << ", " << s << endl << thesis << endl;

}



main()

{

   student       s1("Mae Pohl", 214, 92.3, soph);

   grad_student  s2("Morris Pohl", 421, 91.2, grad, ta, "Pharmacy",

                    "Pharmacies as a retail outlet");



   cout << "\nStudent public classes example:\n";



   s1.print();

   s2.print();



}



