/**********************************************************************



  Filename:  fibona2.cpp

  Chapter:   2      Native Types and Statements

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream.h>



//Idiomatically correct C++

//Fibonacci series incompatible with C

//This code follows the rule of smallest enclosing scope



unsigned fibonacci(unsigned n)

{

   unsigned sum = 0;



   for (unsigned i = 0, f0 = 0, f1 = 1; i < n - 1; ++i){

      sum = f0 + f1;

      f0 = f1;

      f1 = sum;

   }

   if (n > 1)

       return sum;

   else

       return n;

}



main()

{

   unsigned  n = 2;



   cout << "\nEnter a number greater than 1 for fibonacci: ";

   cin >> n;

   while (n > 1) {

      cout << "\nFor " << n << ", the fibonacci number is " << fibonacci(n);

      cout << "\nEnter a number greater than 1 for fibonacci: ";

      cin >> n;

   }

}

