/**********************************************************************



  Filename:  ch_stac1.h

  Chapter:   4      Classes

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



class ch_stack {

public:

   void  reset() { top = EMPTY; }

   void  push(char c) { top++; s[top] = c; }

   char  pop() { return s[top--]; }

   char  top_of() const { return s[top]; }

   bool  empty() const { return (top == EMPTY);}

   bool  full() const { return (top == FULL); }

private:

   enum { max_len = 100, EMPTY = -1, FULL = max_len-1 };

   char  s[max_len];

   int   top;

};



