/**********************************************************************



  Filename:  point5.cpp

  Chapter:   5      Constructors and Destructors

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream>

//using namespace std;



class point {

   double x, y;        //implicitly private

public:

   point() { x = 0; y = 0; }                   //default

   point(double u) { x = u; y = 0;}            //double to point

   point(double u, double v) { x = u; y = v; }



   void print() { cout << "(" << x << "," << y << ")"; }

   void init(double u, double v) { x = u; y = v; }

   void plus(point c);

};



void point::plus(point c)     //definition not inline

{

//offset the existing point by point c

   x += c.x;

   y += c.y;

}





int main()

{

   point w1, w2(1.1), w3(2.2, 3.3);



   cout << "\npoint w1 = ";

   w1.print();

   cout << "\npoint w2 = ";

   w2.print();

   cout << "\npoint w3 = ";

   w3.print();

   w3.plus(w2);

   cout << "\npoint w3 after plus = ";

   w3.print();

   int look; cin >> look;

}

