/**********************************************************************



  Filename:  bad_cast.cpp

  Chapter:   9      Exceptions

  Compiler:  Borland C++     Version 5.01      Summer 1998

  C++ for C Programmers, Edition 3     By Ira Pohl





********************************************************************/



#include <iostream>

#include <stdexception>

#include <typeinfo>

using namespace std;



class A {

public:

  virtual void foo() { cout << "in A" << endl; }

};



class B: public A {

public:

  void foo() { cout << "in B" << endl; }

};



int main()

{

   try {

      A a, *pa; B b, *pb;

      pa = &b;

      pb = dynamic_cast<B*>(pa);      //succeeds

      pb -> foo();

      pa = &a;

      pb = dynamic_cast<B*>(pa);      //fails

      pb -> foo();

   }

   catch(bad_cast) { cout << "dynamic_cast failed" << endl; }

   int look; cin >> look;

}

